;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; SMW Sumo Brother (sprite 9A), by imamelia
;;
;; This is a disassembly of sprite 9A in SMW, the Sumo Brother.
;;
;; Uses first extra bit: NO
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; defines and tables
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

XSpeed:
db $20,$E0

XDisp:
db $FF,$07,$FC,$04,$FF,$07,$FC,$04
db $FF,$FF,$FC,$04,$FF,$FF,$FC,$04
db $02,$02,$F4,$04,$02,$02,$F4,$04
db $09,$01,$04,$FC,$09,$01,$04,$FC
db $01,$01,$04,$FC,$01,$01,$04,$FC
db $FF,$FF,$0C,$FC,$FF,$FF,$0C,$FC

YDisp:
db $F8,$F8,$00,$00,$F8,$F8,$00,$00
db $F8,$F0,$00,$00,$F8,$F8,$00,$00
db $F8,$F8,$01,$00,$F8,$F8,$FF,$00

Tilemap:
db $98,$99,$A7,$A8,$98,$99,$AA,$AB
db $8A,$66,$AA,$AB,$EE,$EE,$C5,$C6
db $80,$80,$C1,$C3,$80,$80,$C1,$C3

TileSize:
db $00,$00,$02,$02,$00,$00,$02,$02
db $02,$02,$02,$02,$02,$02,$02,$02
db $02,$02,$02,$02,$02,$02,$02,$02

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; init routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc

LDA #$03		;
STA $C2,x	;
LDA #$70		;
STA $1540,x	;

RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine wrapper
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "MAIN ",pc
PHB
PHK
PLB
JSR SumoBrotherMain
PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SumoBrotherMain:

JSR SumoBroGFX	; draw the Sumo Brother

LDA $9D		;
BNE Return00	;
LDA $14C8,x	; return if sprites are locked or the sprite is not in normal status
CMP #$08		;
BNE Return00	;

JSR SubOffscreenX0	; offscreen code
JSL $81803A	; interact with the player and with other sprites
JSL $81802A	; update sprite position based on speed values

LDA $1588,x	;
AND #$04	; if the sprite is on the ground...
BEQ RunStateCode	;
STZ $AA,x	; give it zero X speed and zero Y speed
STZ $B6,x		;

RunStateCode:	;

LDA $C2,x	; sprite state
JSL $8086DF	; 16-bit pointer subroutine

dw State00	;
dw State01	;
dw State02	;
dw State03	;

Return00:		;
RTS		;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; code for sprite state 00
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

State00:

LDA #$01		;
STA $1602,x	; animation frame = 01
LDA $1540,x	; if the state-change timer has reached zero...
BNE Return00	;
STZ $1602,x	; set the animation frame to 00,
LDA #$03		;

SetTimer1:	;

STA $1540,x	; the timer to 03,
INC $C2,x	; and the sprite state to 01

Return01:		;
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; code for sprite state 01
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

State01:

LDA $1540,x	;
BNE Return01	;
INC $1602,x	; here, we want to increment the animation frame
LDA #$03		;
BRA SetTimer1	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; code for sprite state 02
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

State02:

LDA $1558,x	;
BNE SetFrame01	;
LDY $157C,x	;
LDA XSpeed,y	;
STA $B6,x		;

LDA $1540,x	;
BNE Return01	;

INC $1570,x		;
LDA $1570,x		;
AND #$01		;
BNE NoResetAniTimer	;
LDA #$20			;
STA $1558,x		;
NoResetAniTimer:	;

LDA $1570,x	;
CMP #$03		;
BNE SetTimer2	;
STZ $1570,x	;
LDA #$70		;
BRA SetTimer1	;

SetTimer2:	;

LDA #$03		;

SetTimer3:	;

JSR SetTimer1	;
STZ $C2,x	;
RTS

SetFrame01:

LDA #$01		;
STA $1602,x	;
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; code for sprite state 03
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

State03:

LDA #$03		;
LDY $1540,x	;
BEQ Turn		;
CPY #$2E		;
BNE NoLightning	;
PHA		;
LDA $15A0,x	;
ORA $186C,x	;
BNE PullAndSkip	;

LDA #$30		;
STA $1887	;
LDA #$09		;
STA $1DFC	;
PHY		;

JSR GenSumoLightning

PLY		;

PullAndSkip:

PLA

NoLightning:

CPY #$30		;
BCC SetFrameX	;
CPY #$50		;
BCS SetFrameX	;
INC		;
CPY #$44		;
BCS SetFrameX	;
INC		;
SetFrameX:	;
STA $1602,x	;
RTS

Turn:

LDA $157C,x	;
EOR #$01		;
STA $157C,x	;
LDA #$40		;
BRA SetTimer3	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; lightning generation subroutine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GenSumoLightning:

JSL $82A9E4	;
BMI Return02	;

LDA #$2B		;
STA $009E,y	;
LDA #$08		;
STA $14C8,y	;

LDA $E4,x	;
ADC #$04	;
STA $00E4,y	;
LDA $14E0,x	;
ADC #$00	;
STA $14E0,y	;
LDA $D8,x	;
STA $00D8,y	;
LDA $14D4,x	;
STA $14D4,y	;

PHX		;
TYX		;
JSL $87F7D2	;
LDA #$10		;
STA $1FE2,x	;
PLX		;

Return02:		;
RTS		;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; graphics routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SumoBroGFX:

JSR GetDrawInfo	;

LDA $157C,x	;
LSR		;
ROR #2		;
AND #$40	;
EOR #$40		;
STA $02		;

;LDY $15EA,x	;
LDA $1602,x	;
ASL #2		;
PHX		;
TAX		;
LDA #$03		;
STA $05		; 

GFXLoop:

PHX		;
LDA $02		;
BEQ NoXShift	;
TXA		;
CLC		;
ADC #$18	;
TAX		;
NoXShift:		;
LDA $00		;
CLC		;
ADC XDisp,x	;
STA $0300,y	;

PLX		;
LDA $01		;
CLC		;
ADC YDisp,x	;
STA $0301,y	;

LDA Tilemap,x	;
STA $0302,y	;

CMP #$66		;
SEC		;
BNE SetGFXPage	;
CLC		;
SetGFXPage:	;
LDA #$34		;
ADC $02		;
STA $0303,y	;
      
PHY		;
TYA		;
LSR #2		;
TAY		;
LDA TileSize,x	;
STA $0460,y	;
PLY		;

INY #4		;
INX		;
DEC $05		;
BPL GFXLoop	;

PLX		;
LDY #$FF		;
LDA #$03		;
JSL $81B7B3	;
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; subroutines
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Table1:              db $0C,$1C
Table2:              db $01,$02
Table3:              db $40,$B0
Table6:              db $01,$FF
Table4:              db $30,$C0,$A0,$C0,$A0,$F0,$60,$90,$30,$C0,$A0,$80,$A0,$40,$60,$B0
Table5:              db $01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$00,$01,$FF

SubOffscreenX0:
LDA #$00
;BRA SubOffscreenMain
;SubOffscreenX1:
;LDA #$02
;BRA SubOffscreenMain
;SubOffscreenX2:
;LDA #$04
;BRA SubOffscreenMain
;SubOffscreenX3:
;LDA #$06
;BRA SubOffscreenMain
;SubOffscreenX4:
;LDA #$08
;BRA SubOffscreenMain
;SubOffscreenX5:
;LDA #$0A
;BRA SubOffscreenMain
;SubOffscreenX6:
;LDA #$0C
;BRA SubOffscreenMain
;SubOffscreenX7:
;LDA #$0E

SubOffscreenMain:

STA $03

JSR SubIsOffscreen
BEQ Return2

LDA $5B
LSR
BCS VerticalLevel
LDA $D8,x
CLC
ADC #$50
LDA $14D4,x
ADC #$00
CMP #$02
BPL EraseSprite
LDA $167A,x
AND #$04
BNE Return2
LDA $13
AND #$01
ORA $03
STA $01
TAY
LDA $1A
CLC
ADC Table4,y
ROL $00
CMP $E4,x
PHP
LDA $1B
LSR $00
ADC Table5,y
PLP
SBC $14E0,x
STA $00
LSR $01
BCC Label20
EOR #$80
STA $00
Label20:
LDA $00
BPL Return2

EraseSprite:
LDA $14C8,x
CMP #$08
BCC KillSprite
LDY $161A,x
CPY #$FF
BEQ KillSprite
LDA #$00
STA $1938,y
KillSprite:
STZ $14C8,x
Return2:
RTS

VerticalLevel:

LDA $167A,x
AND #$04
BNE Return2
LDA $13
LSR
BCS Return2
AND #$01
STA $01
TAY
LDA $1C
CLC
ADC Table3,y
ROL $00
CMP $D8,x
PHP
LDA $1D
LSR $00
ADC Table6,y
PLP
SBC $14D4,x
STA $00
LDY $02
BEQ Label22
EOR #$80
STA $00
Label22:
LDA $00
BPL Return2
BMI EraseSprite

SubIsOffscreen:
LDA $15A0,x
ORA $186C,x
RTS

GetDrawInfo:

STZ $186C,x
STZ $15A0,x
LDA $E4,x
CMP $1A
LDA $14E0,x
SBC $1B
BEQ OnscreenX
INC $15A0,x
OnscreenX:
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
SEC
SBC $1A
CLC
ADC.w #$0040
CMP #$0180
SEP #$20
ROL A
AND #$01
STA $15C4,x
BNE Invalid

LDY #$00
LDA $1662,x
AND #$20
BEQ OnscreenLoop
INY
OnscreenLoop:
LDA $D8,x
CLC
ADC Table1,y
PHP
CMP $1C
ROL $00
PLP
LDA $14D4,x
ADC #$00
LSR $00
SBC $1D
BEQ OnscreenY
LDA $186C,x
ORA Table2,y
STA $186C,x
OnscreenY:
DEY
BPL OnscreenLoop
LDY $15EA,x
LDA $E4,x
SEC
SBC $1A
STA $00
LDA $D8,x
SEC
SBC $1C
STA $01
RTS

Invalid:
PLA
PLA
RTS











